%define debug_package %{nil}

%define name libfixbuf
%define version 2.3.1
%define release 1

Summary:	Fixbuf IPFIX implementation library
Name:		%{name}
Version:	%{version}
Release:	%{release}%{?dist}
Group:		Applications/System
License:	LGPLv3
Source:		http://tools.netsa.cert.org/releases/%{name}-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}
Vendor:		http://tools.netsa.cert.org/
URL:		http://tools.netsa.cert.org/fixbuf/

Requires: glib2 >= 2.18
%if "x" == "x1"
Requires: libsctp
%endif
%if "x" == "x1"
Requires: libspread
%endif
%if "x" == "x1"
Requires: openssl
%endif
BuildRequires: glib2-devel >= 2.18
BuildRequires: pkgconfig >= 0.8
%if "x" == "x1"
BuildRequires: libsctp-devel
%endif
%if "x" == "x1"
BuildRequires: libspread-devel
%endif
%if "x" == "x1"
BuildRequires: openssl-devel
%endif

%description
libfixbuf aims to be a compliant implementation of the IPFIX Protocol
and message format, from which IPFIX Collecting Processes and
IPFIX Exporting Processes may be built.

%package devel
Summary: Static libraries and C header files for libfixbuf
Group: Applications/System
Provides: libfixbuf-devel
Requires: %{name} = %{version}
Requires: pkgconfig >= 0.8

%description devel
Static libraries and C header files for libfixbuf.

%package ipfixDump
Group: Applications/System
Summary: Prints the contents of an IPFIX file as text
Requires: %{name} = %{version}

%description ipfixDump
ipfixDump is a libfixbuf-related utility that reads an IPFIX file and
prints its contents as human-readable text.

%prep
%setup -q -n %{name}-%{version}

%build
./configure
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}
%makeinstall

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc AUTHORS LICENSE.txt NEWS README
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so*

%files devel
%defattr(-,root,root)
%doc doc/html
%{_includedir}/*
%{_libdir}/pkgconfig/*

%files ipfixDump
%defattr(-,root,root)
%{_bindir}/ipfixDump
%{_mandir}/man1/ipfixDump.1*
%{_datadir}/%{name}/cert_ipfix.xml

%changelog
* Thu Apr 18 2019 Lawrence R. Rogers <lrr@cert.org> 2.3.1-1
* Release 2.3.1-1
	Fixed a double-freeing of memory and memory leaks in some of the error handling code.

* Mon Mar 18 2019 Lawrence R. Rogers <lrr@cert.org> 2.3.0-1
* Release 2.3.0-1
	Added the ipfixDump application which used to be included with YAF, and made many changes to the application.
	  Use configure --disable-tools to prevent building and installing ipfixDump.
	Fixed bugs in reading and writing information elements whose type was list and elementId was a value other than 291, 292, or 293.
	Information element type information and exporting template metadata.

* Thu Nov 29 2018 Lawrence R. Rogers <lrr@cert.org> 2.2.0-1
* Release 2.2.0-1
	Add functions to return buffer size required to read a template and maximum buffer size to process all known templates in a session.
	Return an error when a user attempts to use a reserved template ID.
	Fix a potential use-after-free bug triggered by pyfixbuf.

* Thu Jul 12 2018 Lawrence R. Rogers <lrr@cert.org> 2.1.0-1
* Release 2.1.0-1
	Add functions to update the Information Model with Information Elements read from a file or a string containing XML data
	Set an element's endian flag when incorporating elements from options records
	GLib 2.18 or later is now required

* Wed May  2 2018 Lawrence R. Rogers <lrr@cert.org> 2.0.0-1
* Release 2.0.0-1
	This version is not backwards-compatible with fixbuf 1.x.
	There are no functional differences between this release and the 1.8 release. All the changes are API changes and internal cleanups.
	Change source for infomodel to the IANA XML version of the IPFIX Information Elements.
	Require information element specifications for internal records to have non-defaulted (non-zero) sizes.
	Simplify new template callbacks, subsuming the three variants with one: fbSessionAddNewTemplateCallback().
	The default is now to consider the source port when separating incoming UDP streams. The function fbCollectorManageUDPStreamByPort() has been removed.
	Change fbInfoElementWriteOptionsRecord() to take both the internal and external template id.
	Update to LGPL 3.

* Tue Nov  7 2017 Lawrence R. Rogers <lrr@cert.org> 1.8.0-1
* Release 1.8.0-1
	The ability to add template metadata to exported templates
	Macro to check fixbuf version number
	Minor bug fixes

* Fri Oct  9 2015 Lawrence R. Rogers <lrr@cert.org> 1.7.1-1
* Release 1.7.1-1
	Bug Fix for NetFlow v9 devices that implement Reverse Information Elements

* Wed Jul  1 2015 Lawrence R. Rogers <lrr@cert.org> 1.7.0-1
* Release 1.7.0-1
	Update IPFIX Information Elements to be compatible with IANA registry
	Add recursive freeing function fBufListFree() to free structured data elements
	Ignore extra filling bytes in sFlow records
	Bug Fix for NetFlow v9 Options Template Parsing
	Other Bug Fixes

* Wed Dec  3 2014 Lawrence R. Rogers <lrr@cert.org> 1.6.2-1
* Release 1.6.2-1
	Bug Fix for NetFlow v9 collectors with multiple streams
	Other Bug Fixes

* Wed Oct 15 2014 Lawrence R. Rogers <lrr@cert.org> 1.6.1-1
* Release 1.6.1-1
	Bug Fix for UDP connections that timeout frequently

* Mon Sep 29 2014 Lawrence R. Rogers <lrr@cert.org> 1.6.0-1
* Release 1.6.0-1
	New Support for sFlow
	Added support for decoding basicLists with unknown information elements
	New Template Callback Function
	Updated IPFIX Information Elements to be compatible with IANA registry

* Wed Jun 18 2014 Lawrence R. Rogers <lrr@cert.org> 1.5.0-1
* Release 1.5.0-1
	Updated IPFIX Information Elements to be compatible with IANA registry
	Added the ability to decode IPFIX from application's own data buffer
	Replaced select() with poll() for fbListeners. Applications will now bind to all addresses returned by getaddrinfo
	Added an InfoModel Iterator
	Removed fbListenerGroupWaitAcceptCallback() API function
	Removed fbListenerWaitAcceptCallback() API function
	Renamed IPFIX Structured Data Type Semantic #defines
	Bug Fix for NetFlow v9 Options Templates
	Other Bug Fixes

* Mon Dec 02 2013 Lawrence R. Rogers <lrr@cert.org> 1.4.0-1
* Release 1.4.0-1
	pyfixbuf, a python API for libfixbuf, is included as a separate package within the tarball (optional install)
	UDP IPFIX Listeners now reject IPFIX messages with invalid version numbers
	Added Environment Variable, FB_SUPPRESS_LOGS, to suppress NetFlow v9 log messages
	NetFlow v9 Options Templates and Records are now collected and translated to IPFIX.
	An fbInfoElement_st now contains all of the properties listed in RFC 5610.
	Added a macro, FB_IE_INIT_FULL, to define an Information Element with additional properties
	New API functions to create Options Templates/Records for encoding Information Element type information.
	New API functions to collect Information Element type records.
	New Template Callback for application to provide context to an incoming Template.
	IPFIX Elements updated to be compatible with IANA registry.
	NetFlow v9 compatible elements added to default Information Model.

* Fri Mar 8 2013 Lawrence R. Rogers <lrr@cert.org> 1.3.0-1
* Release 1.3.0-1
	Maintain count of missed NetFlow v9 export packets per session
	Added API function fbCollectorGetNetflowMissed to retrieve missed packet count
	IPFIX elements updated
	Spread Disconnect Bug fix

* Fri Sep 14 2012 Lawrence R. Rogers <lrr@cert.org> 1.2.0-1
* Release 1.2.0-1
	UDP Collection Enhancements
	Manage UDP sessions by peer address and observation domain

* Thu Jun 7 2012 Lawrence R. Rogers <lrr@cert.org> 1.1.2-1
* Release 1.1.2-1
	Bug fixes
	NetFlow v9 bug fixes

* Thu Dec 22 2011 Lawrence R. Rogers <lrr@cert.org> 1.1.1-1
* Release 1.1.1-1
	Bug fixes

* Mon Sep 12 2011 Lawrence R. Rogers <lrr@cert.org> 1.0.2-1
* Release 1.0.1-1
	Bug fixes

* Wed Jun 1 2011 Lawrence R. Rogers <lrr@cert.org> 1.0.1-1
* Release 1.0.1-1
	Fix to maintain compatibility with GLib prior to version 2.10

* Thu Apr 28 2011 Lawrence R. Rogers <lrr@cert.org> 1.0.0-1
* Release 1.0.0-1
	Added functionality to adhere to the proposed IPFIX extension: "Export of Structured Data in IPFIX". This proposed standard
		allows for the following three new data types.
	Added new data type: fbBasicList_t to house fixbuf "basicLists."
	Added new data type: fbSubTemplateList_t to house fixbuf "subTemplateLists."
	Added new data type: fbSubTemplateMultiList_t to house fixbuf "subTemplateMultiLists."
	Added the functionality to handle multiple listeners, allowing for connections on multiple ports.
	Support for Netflow V9.
	Spread support has been expanded to allow for greater flexibility in using one exporter to publish to multiple groups.
	Templates are now managed on a per-group basis for a Spread exporter.
	Templates can now be multicasted to select Spread groups.
	Default Automatic Mode for Listeners is now set to true.
	Many other bug fixes.

* Tue Jul 27 2010 Lawrence R. Rogers <lrr@cert.org> 0.9.0-1
* Release 0.9.0-1
	Added support for Spread Toolkit to allow publish subscribe distribution of YAF sensor output.
